﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public Segundos2CloseActivity As Long = 100
End Sub

Sub IsValidDate(Date As String) As Boolean
	Try
		DateTime.DateParse(Date)
		Return True
	Catch
		Return False
	End Try
End Sub

PUBLIC Sub DimeHoraFacil(Hora As String, IncluirtxtLA As Boolean) As String
	Dim Hor As Int
	Dim Minut As Int
	Dim Tmp As String
	Dim I As Long
	Dim TxtFalta As String
	
	I = Hora.IndexOf(":")
	Hor = Hora.SubString2(0, I)
	Minut = Hora.SubString2(I+1, Hora.Length)
	
	Tmp =  GetMinutos2TXT(Minut)
	
	
	If Hor > 12 Then
		Hor = Hor - 12
	End If
	
	
	If Minut > 32 Then
'		Falta = 60 - Minut
		
		Hor = Hor + 1

		
		If Hor = 13 Then
			Hor = 1
		End If	
	End If
	
	Dim Ad As String
	Ad =  GetMinutos2TXT(Minut)
	If Hor = 0 Then
		Hor = 12
	End If
	If Ad = "" Then
		
		If Hor = 1 Then
			If IncluirtxtLA Then
				TxtFalta= "La " 
			End If
			TxtFalta = TxtFalta  & Hor & " en PUNTO"
		Else
			If IncluirtxtLA Then
				TxtFalta= "Las "
			End If
			TxtFalta = TxtFalta & Hor &  " en PUNTO"
		End If
		
	Else
		TxtFalta = Hor & " " & Ad
	End If
	
	Return TxtFalta
	
End Sub

PRIVATE Sub GetMinutos2TXT(Minutos As Long) As String
	Dim Tx As String
	If Minutos < 3 Then
		Tx = ""
	else if Minutos < 8 Then
		Tx = "Y CINCO"
	ELSE IF Minutos < 13 Then
		Tx = "Y DIEZ"
	ELSE IF Minutos < 18 Then
		Tx ="Y CUARTO"
	ELSE IF Minutos < 23 Then
		Tx = "Y VEINTE"
	ELSE IF Minutos < 28 Then
		Tx = "Y VENTICINCO"
	Else IF Minutos < 33 Then
		Tx = "Y MEDIA"
	Else IF Minutos < 38 Then
		Tx = "MENOS VENTICINCO"
	ELSE IF Minutos < 43 Then
		Tx = "MENOS VEINTE"
	ELSE IF Minutos < 48 Then
		Tx = "MENOS CUARTO"
	ELSE IF Minutos < 53 Then
		Tx = "MENOS DIEZ"
	ELSE IF Minutos < 58 Then
		Tx = "MENOS CINCO"
	Else
		Tx = ""
	End If
	Return Tx
End Sub


public Sub GetHora(ConSegundos As Boolean)  As String
	Return FormatA2(DateTime.GetHour(DateTime.Now)) & ":" & FormatA2(DateTime.GetMinute(DateTime.Now)) & ":" & FormatA2(DateTime.GetSecond (DateTime.Now)) '   DateTime.Time(DateTime.Now)
End Sub
public Sub GetHoraFormateada(Horas As Int, Minutos As Int) As String
	Return FormatA2(Horas) & ":" & FormatA2(Minutos)
End Sub


public Sub GetHora12(ConSegundos As Boolean)
	Dim H As Long 
	Dim Txt As String 
	h = DateTime.GetHour(DateTime.Now)
	If h > 12 Then
		h = h - 12
	End If
	
	Txt = FormatA2(h) & ":" & FormatA2(DateTime.GetMinute(DateTime.Now))
	If ConSegundos Then
		Txt = Txt &  ":" & FormatA2(DateTime.GetSecond (DateTime.Now))
	End If
	
	Return  Txt '   DateTime.Time(DateTime.Now)

End Sub

public Sub GetHoraFormateada2(Horas As Int, Minutos As Int, Segundos As Int) As String
	Return FormatA2(Horas) & ":" & FormatA2(Minutos) & ":" & FormatA2(Segundos)
End Sub


public  Sub FormatA2(Numero As Int) As String
	Dim T As String
	t = "0" & Numero
	Return modGeneral.Right(T,2)
	
End Sub



public  Sub GetAvisoActual() As TDAviso
	Dim Sql As String
	
	Dim DiaSemana As String
	Dim Fecha As String
	Dim Hora As String
	
	
	Try
		

	
		DiaSemana = GetDiaSemanaHoy
		Fecha = DateTime.Date(DateTime.Now)
		Hora = DateTime.Time(DateTime.Now)
		
		Sql = "Select * From AgendaFacil"
		Sql = Sql & " Where (DiaSemana = '" & DiaSemana & "' Or DiaSemana = 'TODOS' OR DIASEMANA='L-V' OR DIASEMANA = 'S-D' OR Fecha='" & Fecha & "')"
		Sql = Sql & " And Hora >= '" & Hora & "'"
		Sql = Sql & " And Hora <> ''"
		Sql = Sql & "  Order by Hora, DiaSemana, Fecha"
		Dim Cursor As Cursor = modSQL.Sql1.ExecQuery(Sql)
		
		
		Cursor = modSQL.SQL1.ExecQuery(Sql)
		Dim Detectado As Boolean = False 
		Dim Av As TDAviso
		For i = 0 To Cursor.RowCount - 1
			
			Detectado= True 
			Av.Initialize
			Cursor.Position = i
			Av.DiaSemana  = Cursor.GetString("DiaSemana")
			If Av.DiaSemana = "TODOS" Then
				Av.DiaSemana = GetDiaSemanaHoy
				
			else if Av.DiaSemana = "L-V" Then
				If GetHoyEsLaV Then
					Av.DiaSemana = GetDiaSemanaHoy
				Else
					Detectado = False 
				End If
		
			else If Av.DiaSemana = "S-D" Then
				If GetHoyEsLaV = False Then
					Av.DiaSemana = GetDiaSemanaHoy
				Else
					Detectado = False 
				End If
			End If
			If Detectado  Then 
				Av.Aviso = Cursor.GetString("Aviso")
				Av.Fecha = Cursor.GetString("Fecha")
				Av.Hora = Cursor.GetString("Hora")
				Av.MinutosPreAviso= modGeneral.val(Cursor.GetString("MinutosPreAviso"))
				
				If Av.MinutosPreAviso = 0 Then
					Av.MinutosPreAviso = 5
				End If
				
				Av.registro = Cursor.GetString("Registro")
				If Av.Fecha = "" Then
					If GetDiaSemanaHoy=Av.DiaSemana Then
						Av.Fecha = DateTime.Date(DateTime.Now)
					Else
						Av.Fecha = "31/12/2100"
					End If
				End If
				Exit
			Else
				'el aviso será posterior a la hora actual, PERO DE OTRO DÍA.
				Av.Initialize 
		
				
				'a por otro registro 
			End If 
		Next
	
	
	Catch
		Log(LastException)
		ToastMessageShow("Error ModHoras.GetAvisoActual " & LastException.Message,True)
		'Msgbox (LastException.Message,"Error al obtener aviso")
	End Try
	
	Return Av
End Sub

PUBLIC Sub GetHoyEsLaV() As Boolean
	Dim Dia As Int = DateTime.GetDayOfWeek( DateTime.now)
	Select Case Dia
		Case 2,3,4,5,6 'lunes a viernes
			Return True 
		Case 1 'domingo
			Return False 
		Case 7 'sabado
			Return False 
		Case Else 
			Return False 
	End Select
	
End Sub




public Sub GetDiaSemanaHoy() As String

	'Dim Tik As Long = DateUtils.SetDate(td.Year,td.Month,td.DayOfMonth)
		
	Dim Dia As Int = DateTime.GetDayOfWeek(DateTime.now)
	Return GetDiaSemana(Dia)

End Sub

public Sub GetDiaSemana(Dia As Int ) As String
	Dim D As String
	Select Case Dia
		Case 1
			D = "Domingo"
		Case 2
			d = "Lunes"
		Case 3
			D = "Martes"
		Case 4
			D = "Miércoles"
		Case 5
			D = "Jueves"
		Case 6
			D = "Viernes"
		Case 7
			D = "Sábado"
	End Select
	Return D
End Sub
