﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim SegundosTranscurridos As Long = 0
End Sub



Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private txtHora As EditText
	Private txtFecha As EditText
	Private txtAviso As EditText
	Private btEdit As Button
	Private Spinnerdia As Spinner
	Private btHoras As Button
	Private txtMinuto As EditText
	Private txtMinutosPreAviso As EditText
	
	Dim Timer As Timer 
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("LayoutAviso")
	CargarSpiner
	If FirstTime Then 
		If Timer.IsInitialized = False Then 
			Timer.Initialize("Timer1",1000)
			Timer.Enabled = True 
		End If 
	End If 
	Timer1_Tick
End Sub


private Sub Timer1_Tick
	SegundosTranscurridos = SegundosTranscurridos + 1
	Activity.Title = modHoras.GetHora12(True) &  "  (" &  (modHoras.Segundos2CloseActivity - SegundosTranscurridos) & ")"

	If SegundosTranscurridos = modHoras.Segundos2CloseActivity Then
		Activity.Finish 
		
	End If
End Sub



private Sub CargarSpiner
'	Spinner1.AddAll(Array As String("Sunday", "Monday", ...))
	Spinnerdia.ADD ("Seleccione DÍA" )
	Spinnerdia.ADD ("Lunes" )
	Spinnerdia.Add ("Martes")
	Spinnerdia.Add ("Miércoles")
	Spinnerdia.Add ("Jueves")
	Spinnerdia.Add ("Viernes")
	Spinnerdia.Add ("Sábado")
	Spinnerdia.Add ("Domingo")
	Spinnerdia.Add ("TODOS")
	Spinnerdia.Add ("L-V")
	Spinnerdia.Add ("S-D")
End Sub

Sub Activity_Resume
	SegundosTranscurridos = 0
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress(KeyCode As Int) As Boolean 
	SegundosTranscurridos = 0
End Sub

Sub Activity_Touch (Action As Int, x As Float, Y As Float)
	SegundosTranscurridos = 0
End Sub

Sub btSave_Click
	Dim Td As TDAviso
	Try
		
		'TEXTO DEL AVISO
		If txtAviso.Text = "" Then
			Msgbox ("Complete una descripcion para el aviso","Aviso")
			Return 
		End If
		Td.Aviso = txtAviso.Text
		
		'DIA DE LA SEMANA DEL AVISO 
		If Spinnerdia.SelectedIndex < 1 Then
			Msgbox("Complete un día de la semana","Día")
			Spinnerdia.Prompt = "Día semana aviso"			
			Return	
		End If
		Td.DiaSemana = Spinnerdia.GetItem(Spinnerdia.SelectedIndex)
		
		'FECHA DEL AVISO (O EN BLANCO)
		If txtFecha.Text <> "" Then
			If modHoras.IsValidDate(txtFecha.Text) = False Then
				Msgbox ("Complete una fecha correcta o en blanco","Fecha")
				Return
			End If
		End If
		Td.Fecha=txtFecha.Text
	
	
		'HORA DEL AVISO 
		Dim H As Long 
		Dim M As Long
		If txtHora.Text = "" Or txtMinuto.Text = "" Then
			Msgbox ("Indique la hora de aviso","Hora aviso")
			Return
		End If
		
		h = modGeneral.Val(txtHora.Text)
		m = modGeneral.Val(txtMinuto.Text)
		
		If h > 23 Or h < 0  Then
			Msgbox("Horas de 0 a 23","Horas")
			Return 
		End If
		
		If m < 0 Or m > 59 Then
			Msgbox("Minutos entre 0 y 59","Minutos")
			Return 
		End If
		
		Td.Hora =  modHoras.GetHoraFormateada ( h , m)
		
	
		
		
		
		
		'MINUTOS DE ANTICIPACIÓN DEL AVISO 
		Td.MinutosPreAviso = modGeneral.Val(txtMinutosPreAviso.Text)
		If Td.MinutosPreAviso < 1  Then
			Msgbox("Los minutos previos de aviso debe ser superior a 1","Minutos Aviso Previo")
			Return 
		End If
		
		
		
		
		
		'SI TIENE EL AVISO UN TAG, ES QUE ES UNA MODIFICACIÓN DE REGISTRO
		If txtAviso.Tag = "" Then 
			modSQL.RegistroInsert(Td)
			Msgbox ("Insertado","Insertado")
			Limpiar
		Else
			Td.Registro = txtAviso.Tag 
			modSQL.RegistroUpdate  (Td)
			Limpiar
			'Msgbox ("Modificado","Modificado")
			CallSubDelayed(ActAvisos,"Actualizado")
			Activity.Finish 
		End If 

	
	
	Catch
		Msgbox(LastException.Message,"Error al guardar")
	End Try
	
End Sub



private Sub Limpiar
	'txtAviso.Text = ""

	'txtFecha.Text = ""
	'txtHora.Text = ""
	'txtMinuto.Text =""
	Spinnerdia.SelectedIndex=0
	txtAviso.Tag = ""
	Activity.Color = Colors.Black 
End Sub

Sub btEdit_Click
	StartActivity(ActAvisos)
End Sub



Sub btHoras_Click
	Dim td As TimeDialog
	Try
		td.Hour = modGeneral.val(txtHora.Text) 
		td.Minute = modGeneral.Val(txtMinuto.Text)
		If td.Show("Hora Aviso","Aviso","Aceptar","Cancelar","",Null) = DialogResponse.POSITIVE Then
			txtHora.Text = modHoras.FormatA2 (td.Hour)
			txtMinuto.Text = modHoras.FormatA2( td.Minute )
		End If
	Catch
		Log(LastException)
		ToastMessageShow("Error ActAviso.BtHoras_Click" & LastException.Message,True)
	End Try
End Sub

Sub showFecha
	Dim td As DateDialog
	'Msgbox(td.Version,"")
	td.Year = DateTime.GetYear(DateTime.Now)
	td.Month = DateTime.GetMonth(DateTime.Now)
	td.DayOfMonth= DateTime.GetDayOfMonth(DateTime.Now)
	If td.Show("Fecha Aviso Fijo","Fecha","Aceptar","Cancelar","",Null) = DialogResponse.POSITIVE Then
		txtFecha.Text = td.DayOfMonth & "/" &  td.Month & "/" & td.Year 
		Dim Tik As Long = DateUtils.SetDate(td.Year,td.Month,td.DayOfMonth)
		
		Dim Dia As String =  modHoras.GetDiasemana(DateTime.GetDayOfWeek(Tik))
		SetDiaSemana(Dia)
	End If
End Sub

Sub SetDiaSemana(DiaTxt As String)
	Dim F As Int
	For f  = 0 To Spinnerdia.Size  -1
		If Spinnerdia.GetItem(f) = DiaTxt Then
			Spinnerdia.SelectedIndex= f
			Exit
		End If
	Next
End Sub


Sub Modificar(Aviso As TDAviso)
	txtAviso.Text = Aviso.Aviso 
	txtFecha.Text = Aviso.Fecha
	txtHora.Text = Aviso.Hora.SubString2(0,2 )
	txtMinuto.Text = Aviso.Hora.SubString(3 )
	txtMinutosPreAviso.Text = Aviso.MinutosPreAviso
	SetDiaSemana(Aviso.DiaSemana)
	txtAviso.Tag = Aviso.Registro 
	Activity.Color = Colors.Blue 
	
End Sub

Sub btFecha_Click
	showFecha
End Sub

Sub lblBack_Click
	Activity.Finish 
End Sub